/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 14:24:35 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit;

/**
 * Service definition for Identitytoolkit (v3).
 *
 * <p>
 * Help the third party sites to implement federated login.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/identity-toolkit/v3/" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link IdentitytoolkitRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Identitytoolkit extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    com.google.api.client.util.Preconditions.checkState(
        com.google.api.client.googleapis.GoogleUtils.MAJOR_VERSION == 1 &&
        com.google.api.client.googleapis.GoogleUtils.MINOR_VERSION == 14,
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.14 of google-api-client to run version " +
        "1.14.2-beta of the Google Identity Toolkit API library.", com.google.api.client.googleapis.GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "identitytoolkit/v3/relyingparty/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   */
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport, which should normally be:
   *        <ul>
   *        <li>Google App Engine:
   *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
   *        <li>Android: {@code newCompatibleTransport} from
   *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
   *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
   *        </li>
   *        </ul>
   * @param jsonFactory JSON factory, which may be:
   *        <ul>
   *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
   *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
   *        <li>Android Honeycomb or higher:
   *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
   *        </ul>
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Identitytoolkit(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
      com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
    this(new Builder(transport, jsonFactory, httpRequestInitializer));
  }

  /**
   * @param builder builder
   */
  Identitytoolkit(Builder builder) {
    super(builder);
  }

  @Override
  protected void initialize(com.google.api.client.googleapis.services.AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Relyingparty collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Identitytoolkit identitytoolkit = new Identitytoolkit(...);}
   *   {@code Identitytoolkit.Relyingparty.List request = identitytoolkit.relyingparty().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Relyingparty relyingparty() {
    return new Relyingparty();
  }

  /**
   * The "relyingparty" collection of methods.
   */
  public class Relyingparty {

    /**
     * Creates the URI used by the IdP to authenticate the user.
     *
     * Create a request for the method "relyingparty.createAuthUri".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link CreateAuthUri#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyCreateAuthUriRequest}
     * @return the request
     */
    public CreateAuthUri createAuthUri(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyCreateAuthUriRequest content) throws java.io.IOException {
      CreateAuthUri result = new CreateAuthUri(content);
      initialize(result);
      return result;
    }

    public class CreateAuthUri extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "createAuthUri";

      /**
       * Creates the URI used by the IdP to authenticate the user.
       *
       * Create a request for the method "relyingparty.createAuthUri".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link CreateAuthUri#execute()} method to invoke the remote
       * operation. <p> {@link CreateAuthUri#initialize(com.google.api.client.googleapis.services.Abstra
       * ctGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyCreateAuthUriRequest}
       * @since 1.13
       */
      protected CreateAuthUri(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyCreateAuthUriRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public CreateAuthUri setAlt(java.lang.String alt) {
        return (CreateAuthUri) super.setAlt(alt);
      }

      @Override
      public CreateAuthUri setFields(java.lang.String fields) {
        return (CreateAuthUri) super.setFields(fields);
      }

      @Override
      public CreateAuthUri setKey(java.lang.String key) {
        return (CreateAuthUri) super.setKey(key);
      }

      @Override
      public CreateAuthUri setOauthToken(java.lang.String oauthToken) {
        return (CreateAuthUri) super.setOauthToken(oauthToken);
      }

      @Override
      public CreateAuthUri setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (CreateAuthUri) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public CreateAuthUri setQuotaUser(java.lang.String quotaUser) {
        return (CreateAuthUri) super.setQuotaUser(quotaUser);
      }

      @Override
      public CreateAuthUri setUserIp(java.lang.String userIp) {
        return (CreateAuthUri) super.setUserIp(userIp);
      }

      @Override
      public CreateAuthUri set(String parameterName, Object value) {
        return (CreateAuthUri) super.set(parameterName, value);
      }
    }
    /**
     * Delete user account.
     *
     * Create a request for the method "relyingparty.deleteAccount".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link DeleteAccount#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyDeleteAccountRequest}
     * @return the request
     */
    public DeleteAccount deleteAccount(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyDeleteAccountRequest content) throws java.io.IOException {
      DeleteAccount result = new DeleteAccount(content);
      initialize(result);
      return result;
    }

    public class DeleteAccount extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "deleteAccount";

      /**
       * Delete user account.
       *
       * Create a request for the method "relyingparty.deleteAccount".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link DeleteAccount#execute()} method to invoke the remote
       * operation. <p> {@link DeleteAccount#initialize(com.google.api.client.googleapis.services.Abstra
       * ctGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyDeleteAccountRequest}
       * @since 1.13
       */
      protected DeleteAccount(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyDeleteAccountRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public DeleteAccount setAlt(java.lang.String alt) {
        return (DeleteAccount) super.setAlt(alt);
      }

      @Override
      public DeleteAccount setFields(java.lang.String fields) {
        return (DeleteAccount) super.setFields(fields);
      }

      @Override
      public DeleteAccount setKey(java.lang.String key) {
        return (DeleteAccount) super.setKey(key);
      }

      @Override
      public DeleteAccount setOauthToken(java.lang.String oauthToken) {
        return (DeleteAccount) super.setOauthToken(oauthToken);
      }

      @Override
      public DeleteAccount setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (DeleteAccount) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public DeleteAccount setQuotaUser(java.lang.String quotaUser) {
        return (DeleteAccount) super.setQuotaUser(quotaUser);
      }

      @Override
      public DeleteAccount setUserIp(java.lang.String userIp) {
        return (DeleteAccount) super.setUserIp(userIp);
      }

      @Override
      public DeleteAccount set(String parameterName, Object value) {
        return (DeleteAccount) super.set(parameterName, value);
      }
    }
    /**
     * Returns the account info.
     *
     * Create a request for the method "relyingparty.getAccountInfo".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link GetAccountInfo#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyGetAccountInfoRequest}
     * @return the request
     */
    public GetAccountInfo getAccountInfo(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyGetAccountInfoRequest content) throws java.io.IOException {
      GetAccountInfo result = new GetAccountInfo(content);
      initialize(result);
      return result;
    }

    public class GetAccountInfo extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "getAccountInfo";

      /**
       * Returns the account info.
       *
       * Create a request for the method "relyingparty.getAccountInfo".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link GetAccountInfo#execute()} method to invoke the remote
       * operation. <p> {@link GetAccountInfo#initialize(com.google.api.client.googleapis.services.Abstr
       * actGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyGetAccountInfoRequest}
       * @since 1.13
       */
      protected GetAccountInfo(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyGetAccountInfoRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public GetAccountInfo setAlt(java.lang.String alt) {
        return (GetAccountInfo) super.setAlt(alt);
      }

      @Override
      public GetAccountInfo setFields(java.lang.String fields) {
        return (GetAccountInfo) super.setFields(fields);
      }

      @Override
      public GetAccountInfo setKey(java.lang.String key) {
        return (GetAccountInfo) super.setKey(key);
      }

      @Override
      public GetAccountInfo setOauthToken(java.lang.String oauthToken) {
        return (GetAccountInfo) super.setOauthToken(oauthToken);
      }

      @Override
      public GetAccountInfo setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (GetAccountInfo) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public GetAccountInfo setQuotaUser(java.lang.String quotaUser) {
        return (GetAccountInfo) super.setQuotaUser(quotaUser);
      }

      @Override
      public GetAccountInfo setUserIp(java.lang.String userIp) {
        return (GetAccountInfo) super.setUserIp(userIp);
      }

      @Override
      public GetAccountInfo set(String parameterName, Object value) {
        return (GetAccountInfo) super.set(parameterName, value);
      }
    }
    /**
     * Get a code for user action confirmation.
     *
     * Create a request for the method "relyingparty.getOobConfirmationCode".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link GetOobConfirmationCode#execute()} method to invoke the
     * remote operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.Relyingparty}
     * @return the request
     */
    public GetOobConfirmationCode getOobConfirmationCode(com.google.api.services.identitytoolkit.model.Relyingparty content) throws java.io.IOException {
      GetOobConfirmationCode result = new GetOobConfirmationCode(content);
      initialize(result);
      return result;
    }

    public class GetOobConfirmationCode extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "getOobConfirmationCode";

      /**
       * Get a code for user action confirmation.
       *
       * Create a request for the method "relyingparty.getOobConfirmationCode".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link GetOobConfirmationCode#execute()} method to invoke the
       * remote operation. <p> {@link GetOobConfirmationCode#initialize(com.google.api.client.googleapis
       * .services.AbstractGoogleClientRequest)} must be called to initialize this instance immediately
       * after invoking the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.Relyingparty}
       * @since 1.13
       */
      protected GetOobConfirmationCode(com.google.api.services.identitytoolkit.model.Relyingparty content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public GetOobConfirmationCode setAlt(java.lang.String alt) {
        return (GetOobConfirmationCode) super.setAlt(alt);
      }

      @Override
      public GetOobConfirmationCode setFields(java.lang.String fields) {
        return (GetOobConfirmationCode) super.setFields(fields);
      }

      @Override
      public GetOobConfirmationCode setKey(java.lang.String key) {
        return (GetOobConfirmationCode) super.setKey(key);
      }

      @Override
      public GetOobConfirmationCode setOauthToken(java.lang.String oauthToken) {
        return (GetOobConfirmationCode) super.setOauthToken(oauthToken);
      }

      @Override
      public GetOobConfirmationCode setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (GetOobConfirmationCode) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public GetOobConfirmationCode setQuotaUser(java.lang.String quotaUser) {
        return (GetOobConfirmationCode) super.setQuotaUser(quotaUser);
      }

      @Override
      public GetOobConfirmationCode setUserIp(java.lang.String userIp) {
        return (GetOobConfirmationCode) super.setUserIp(userIp);
      }

      @Override
      public GetOobConfirmationCode set(String parameterName, Object value) {
        return (GetOobConfirmationCode) super.set(parameterName, value);
      }
    }
    /**
     * Set account info for a user.
     *
     * Create a request for the method "relyingparty.resetPassword".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link ResetPassword#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyResetPasswordRequest}
     * @return the request
     */
    public ResetPassword resetPassword(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyResetPasswordRequest content) throws java.io.IOException {
      ResetPassword result = new ResetPassword(content);
      initialize(result);
      return result;
    }

    public class ResetPassword extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "resetPassword";

      /**
       * Set account info for a user.
       *
       * Create a request for the method "relyingparty.resetPassword".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link ResetPassword#execute()} method to invoke the remote
       * operation. <p> {@link ResetPassword#initialize(com.google.api.client.googleapis.services.Abstra
       * ctGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyResetPasswordRequest}
       * @since 1.13
       */
      protected ResetPassword(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyResetPasswordRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public ResetPassword setAlt(java.lang.String alt) {
        return (ResetPassword) super.setAlt(alt);
      }

      @Override
      public ResetPassword setFields(java.lang.String fields) {
        return (ResetPassword) super.setFields(fields);
      }

      @Override
      public ResetPassword setKey(java.lang.String key) {
        return (ResetPassword) super.setKey(key);
      }

      @Override
      public ResetPassword setOauthToken(java.lang.String oauthToken) {
        return (ResetPassword) super.setOauthToken(oauthToken);
      }

      @Override
      public ResetPassword setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (ResetPassword) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public ResetPassword setQuotaUser(java.lang.String quotaUser) {
        return (ResetPassword) super.setQuotaUser(quotaUser);
      }

      @Override
      public ResetPassword setUserIp(java.lang.String userIp) {
        return (ResetPassword) super.setUserIp(userIp);
      }

      @Override
      public ResetPassword set(String parameterName, Object value) {
        return (ResetPassword) super.set(parameterName, value);
      }
    }
    /**
     * Set account info for a user.
     *
     * Create a request for the method "relyingparty.setAccountInfo".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link SetAccountInfo#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartySetAccountInfoRequest}
     * @return the request
     */
    public SetAccountInfo setAccountInfo(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartySetAccountInfoRequest content) throws java.io.IOException {
      SetAccountInfo result = new SetAccountInfo(content);
      initialize(result);
      return result;
    }

    public class SetAccountInfo extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "setAccountInfo";

      /**
       * Set account info for a user.
       *
       * Create a request for the method "relyingparty.setAccountInfo".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link SetAccountInfo#execute()} method to invoke the remote
       * operation. <p> {@link SetAccountInfo#initialize(com.google.api.client.googleapis.services.Abstr
       * actGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartySetAccountInfoRequest}
       * @since 1.13
       */
      protected SetAccountInfo(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartySetAccountInfoRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public SetAccountInfo setAlt(java.lang.String alt) {
        return (SetAccountInfo) super.setAlt(alt);
      }

      @Override
      public SetAccountInfo setFields(java.lang.String fields) {
        return (SetAccountInfo) super.setFields(fields);
      }

      @Override
      public SetAccountInfo setKey(java.lang.String key) {
        return (SetAccountInfo) super.setKey(key);
      }

      @Override
      public SetAccountInfo setOauthToken(java.lang.String oauthToken) {
        return (SetAccountInfo) super.setOauthToken(oauthToken);
      }

      @Override
      public SetAccountInfo setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (SetAccountInfo) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public SetAccountInfo setQuotaUser(java.lang.String quotaUser) {
        return (SetAccountInfo) super.setQuotaUser(quotaUser);
      }

      @Override
      public SetAccountInfo setUserIp(java.lang.String userIp) {
        return (SetAccountInfo) super.setUserIp(userIp);
      }

      @Override
      public SetAccountInfo set(String parameterName, Object value) {
        return (SetAccountInfo) super.set(parameterName, value);
      }
    }
    /**
     * Batch upload existing user accounts.
     *
     * Create a request for the method "relyingparty.uploadAccount".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link UploadAccount#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyUploadAccountRequest}
     * @return the request
     */
    public UploadAccount uploadAccount(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyUploadAccountRequest content) throws java.io.IOException {
      UploadAccount result = new UploadAccount(content);
      initialize(result);
      return result;
    }

    public class UploadAccount extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "uploadAccount";

      /**
       * Batch upload existing user accounts.
       *
       * Create a request for the method "relyingparty.uploadAccount".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link UploadAccount#execute()} method to invoke the remote
       * operation. <p> {@link UploadAccount#initialize(com.google.api.client.googleapis.services.Abstra
       * ctGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyUploadAccountRequest}
       * @since 1.13
       */
      protected UploadAccount(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyUploadAccountRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public UploadAccount setAlt(java.lang.String alt) {
        return (UploadAccount) super.setAlt(alt);
      }

      @Override
      public UploadAccount setFields(java.lang.String fields) {
        return (UploadAccount) super.setFields(fields);
      }

      @Override
      public UploadAccount setKey(java.lang.String key) {
        return (UploadAccount) super.setKey(key);
      }

      @Override
      public UploadAccount setOauthToken(java.lang.String oauthToken) {
        return (UploadAccount) super.setOauthToken(oauthToken);
      }

      @Override
      public UploadAccount setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (UploadAccount) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public UploadAccount setQuotaUser(java.lang.String quotaUser) {
        return (UploadAccount) super.setQuotaUser(quotaUser);
      }

      @Override
      public UploadAccount setUserIp(java.lang.String userIp) {
        return (UploadAccount) super.setUserIp(userIp);
      }

      @Override
      public UploadAccount set(String parameterName, Object value) {
        return (UploadAccount) super.set(parameterName, value);
      }
    }
    /**
     * Verifies the assertion returned by the IdP.
     *
     * Create a request for the method "relyingparty.verifyAssertion".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link VerifyAssertion#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyAssertionRequest}
     * @return the request
     */
    public VerifyAssertion verifyAssertion(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyAssertionRequest content) throws java.io.IOException {
      VerifyAssertion result = new VerifyAssertion(content);
      initialize(result);
      return result;
    }

    public class VerifyAssertion extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "verifyAssertion";

      /**
       * Verifies the assertion returned by the IdP.
       *
       * Create a request for the method "relyingparty.verifyAssertion".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link VerifyAssertion#execute()} method to invoke the remote
       * operation. <p> {@link VerifyAssertion#initialize(com.google.api.client.googleapis.services.Abst
       * ractGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyAssertionRequest}
       * @since 1.13
       */
      protected VerifyAssertion(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyAssertionRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public VerifyAssertion setAlt(java.lang.String alt) {
        return (VerifyAssertion) super.setAlt(alt);
      }

      @Override
      public VerifyAssertion setFields(java.lang.String fields) {
        return (VerifyAssertion) super.setFields(fields);
      }

      @Override
      public VerifyAssertion setKey(java.lang.String key) {
        return (VerifyAssertion) super.setKey(key);
      }

      @Override
      public VerifyAssertion setOauthToken(java.lang.String oauthToken) {
        return (VerifyAssertion) super.setOauthToken(oauthToken);
      }

      @Override
      public VerifyAssertion setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (VerifyAssertion) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public VerifyAssertion setQuotaUser(java.lang.String quotaUser) {
        return (VerifyAssertion) super.setQuotaUser(quotaUser);
      }

      @Override
      public VerifyAssertion setUserIp(java.lang.String userIp) {
        return (VerifyAssertion) super.setUserIp(userIp);
      }

      @Override
      public VerifyAssertion set(String parameterName, Object value) {
        return (VerifyAssertion) super.set(parameterName, value);
      }
    }
    /**
     * Verifies the user entered password.
     *
     * Create a request for the method "relyingparty.verifyPassword".
     *
     * This request holds the parameters needed by the the identitytoolkit server.  After setting any
     * optional parameters, call the {@link VerifyPassword#execute()} method to invoke the remote
     * operation.
     *
     * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyPasswordRequest}
     * @return the request
     */
    public VerifyPassword verifyPassword(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyPasswordRequest content) throws java.io.IOException {
      VerifyPassword result = new VerifyPassword(content);
      initialize(result);
      return result;
    }

    public class VerifyPassword extends IdentitytoolkitRequest<com.google.api.services.identitytoolkit.model.Relyingparty> {

      private static final String REST_PATH = "verifyPassword";

      /**
       * Verifies the user entered password.
       *
       * Create a request for the method "relyingparty.verifyPassword".
       *
       * This request holds the parameters needed by the the identitytoolkit server.  After setting any
       * optional parameters, call the {@link VerifyPassword#execute()} method to invoke the remote
       * operation. <p> {@link VerifyPassword#initialize(com.google.api.client.googleapis.services.Abstr
       * actGoogleClientRequest)} must be called to initialize this instance immediately after invoking
       * the constructor. </p>
       *
       * @param content the {@link com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyPasswordRequest}
       * @since 1.13
       */
      protected VerifyPassword(com.google.api.services.identitytoolkit.model.IdentitytoolkitRelyingpartyVerifyPasswordRequest content) {
        super(Identitytoolkit.this, "POST", REST_PATH, content, com.google.api.services.identitytoolkit.model.Relyingparty.class);
      }

      @Override
      public VerifyPassword setAlt(java.lang.String alt) {
        return (VerifyPassword) super.setAlt(alt);
      }

      @Override
      public VerifyPassword setFields(java.lang.String fields) {
        return (VerifyPassword) super.setFields(fields);
      }

      @Override
      public VerifyPassword setKey(java.lang.String key) {
        return (VerifyPassword) super.setKey(key);
      }

      @Override
      public VerifyPassword setOauthToken(java.lang.String oauthToken) {
        return (VerifyPassword) super.setOauthToken(oauthToken);
      }

      @Override
      public VerifyPassword setPrettyPrint(java.lang.Boolean prettyPrint) {
        return (VerifyPassword) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public VerifyPassword setQuotaUser(java.lang.String quotaUser) {
        return (VerifyPassword) super.setQuotaUser(quotaUser);
      }

      @Override
      public VerifyPassword setUserIp(java.lang.String userIp) {
        return (VerifyPassword) super.setUserIp(userIp);
      }

      @Override
      public VerifyPassword set(String parameterName, Object value) {
        return (VerifyPassword) super.set(parameterName, value);
      }
    }

  }

  /**
   * Builder for {@link Identitytoolkit}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport, which should normally be:
     *        <ul>
     *        <li>Google App Engine:
     *        {@code com.google.api.client.extensions.appengine.http.UrlFetchTransport}</li>
     *        <li>Android: {@code newCompatibleTransport} from
     *        {@code com.google.api.client.extensions.android.http.AndroidHttp}</li>
     *        <li>Java: {@link com.google.api.client.googleapis.javanet.GoogleNetHttpTransport#newTrustedTransport()}
     *        </li>
     *        </ul>
     * @param jsonFactory JSON factory, which may be:
     *        <ul>
     *        <li>Jackson: {@code com.google.api.client.json.jackson2.JacksonFactory}</li>
     *        <li>Google GSON: {@code com.google.api.client.json.gson.GsonFactory}</li>
     *        <li>Android Honeycomb or higher:
     *        {@code com.google.api.client.extensions.android.json.AndroidJsonFactory}</li>
     *        </ul>
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(com.google.api.client.http.HttpTransport transport, com.google.api.client.json.JsonFactory jsonFactory,
        com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Identitytoolkit}. */
    @Override
    public Identitytoolkit build() {
      return new Identitytoolkit(this);
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(com.google.api.client.http.HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    @Override
    public Builder setSuppressRequiredParameterChecks(boolean suppressRequiredParameterChecks) {
      return (Builder) super.setSuppressRequiredParameterChecks(suppressRequiredParameterChecks);
    }

    @Override
    public Builder setSuppressAllChecks(boolean suppressAllChecks) {
      return (Builder) super.setSuppressAllChecks(suppressAllChecks);
    }

    /**
     * Set the {@link IdentitytoolkitRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setIdentitytoolkitRequestInitializer(
        IdentitytoolkitRequestInitializer identitytoolkitRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(identitytoolkitRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        com.google.api.client.googleapis.services.GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
